D3D_SDK_VERSION equ 120

D3DFMT_R8G8B8 equ 20
D3DFMT_A8R8G8B8 equ 21
D3DFMT_X8R8G8B8 equ 22
D3DFMT_R5G6B5 equ 23
D3DFMT_X1R5G5B5 equ 24
D3DFMT_A1R5G5B5 equ 25
D3DFMT_A4R4G4B4 equ 26
D3DFMT_R3G3B2 equ 27
D3DFMT_A8 equ 28
D3DFMT_A8R3G3B2 equ 29
D3DFMT_X4R4G4B4 equ 30

D3DFMT_A8P8 equ 40
D3DFMT_P8 equ 41

D3DFMT_L8 equ 50
D3DFMT_A8L8 equ 51
D3DFMT_A4L4 equ 52

D3DFMT_V8U8 equ 60
D3DFMT_L6V5U5 equ 61
D3DFMT_X8L8V8U8 equ 62
D3DFMT_Q8W8V8U8 equ 63
D3DFMT_V16U16 equ 64
D3DFMT_W11V11U10 equ 65

D3DFMT_D16_LOCKABLE equ 70
D3DFMT_D32 equ 71
D3DFMT_D15S1 equ 73
D3DFMT_D24S8 equ 75
D3DFMT_D16 equ 80
D3DFMT_D24X8 equ 77
D3DFMT_D24X4S4 equ 79

D3DFMT_VERTEXDATA equ 100
D3DFMT_INDEX16 equ 101
D3DFMT_INDEX32 equ 102


D3DSWAPEFFECT_DISCARD equ 1
D3DSWAPEFFECT_FLIP equ 2
D3DSWAPEFFECT_COPY equ 3
D3DSWAPEFFECT_COPY_VSYNC equ 4

D3DCREATE_PUREDEVICE equ 10h
D3DCREATE_SOFTWARE_VERTEXPROCESSING equ 20h
D3DCREATE_HARDWARE_VERTEXPROCESSING equ 40h
D3DCREATE_MIXED_VERTEXPROCESSING equ 80h

D3DDEVTYPE_HAL equ 1
D3DDEVTYPE_REF equ 2
D3DDEVTYPE_SW equ 3

D3DADAPTER_DEFAULT equ 0

D3DCLEAR_TARGET equ 1h
D3DCLEAR_ZBUFFER equ 2h
D3DCLEAR_STENCIL equ 4h

QueryInterface equ 0
AddRef equ 4
Release equ 8

ID3D8_RegisterSoftwareDevice equ 12
ID3D8_GetAdapterCount equ 16
ID3D8_GetAdapterIdentifier equ 20
ID3D8_GetAdapterModeCount equ 24
ID3D8_EnumAdapterModes equ 28
ID3D8_GetAdapterDisplayMode equ 32
ID3D8_CheckDeviceType equ 36
ID3D8_CheckDeviceFormat equ 40
ID3D8_CheckDeviceMultiSampleType equ 44
ID3D8_CheckDepthStencilMatch equ 48
ID3D8_GetDeviceCaps equ 52
ID3D8_GetAdapterMonitor equ 56
ID3D8_CreateDevice equ 60

ID3D8Device_TestCooperativeLevel equ 12
ID3D8Device_GetAvailableTextureMem equ 16
ID3D8Device_ResourceManagerDiscardBytes equ 20
ID3D8Device_GetDirect3D equ 24
ID3D8Device_GetDeviceCaps equ 28
ID3D8Device_GetDisplayMode equ 32
ID3D8Device_GetCreationParameters equ 36
ID3D8Device_SetCursorProperties equ 40
ID3D8Device_SetCursorPosition equ 44
ID3D8Device_ShowCursor equ 48
ID3D8Device_CreateAdditionalSwapChain equ 52
ID3D8Device_Reset equ 56
ID3D8Device_Present equ 60
ID3D8Device_GetBackBuffer equ 64
ID3D8Device_GetRasterStatus equ 68
ID3D8Device_SetGammaRamp equ 72
ID3D8Device_GetGammaRamp equ 76
ID3D8Device_CreateTexture equ 80
ID3D8Device_CreateVolumeTexture equ 84
ID3D8Device_CreateCubeTexture equ 88
ID3D8Device_CreateVertexBuffer equ 92
ID3D8Device_CreateIndexBuffer equ 96
ID3D8Device_CreateRenderTarget equ 100
ID3D8Device_CreateDepthStencilSurface equ 104
ID3D8Device_CreateImageSurface equ 108
ID3D8Device_CopyRects equ 112
ID3D8Device_UpdateTexture equ 116
ID3D8Device_GetFrontBuffer equ 120
ID3D8Device_SetRenderTarget equ 124
ID3D8Device_GetRenderTarget equ 128
ID3D8Device_GetDepthStencilSurface equ 132
ID3D8Device_BeginScene equ 136
ID3D8Device_EndScene equ 140
ID3D8Device_Clear equ 144
ID3D8Device_SetTransform equ 148
ID3D8Device_GetTransform equ 152
ID3D8Device_MultiplyTransform equ 156
ID3D8Device_SetViewport equ 160
ID3D8Device_GetViewport equ 164
ID3D8Device_SetMaterial equ 168
ID3D8Device_GetMaterial equ 172
ID3D8Device_SetLight equ 176
ID3D8Device_GetLight equ 180
ID3D8Device_LightEnable equ 184
ID3D8Device_GetLightEnable equ 188
ID3D8Device_SetClipPlane equ 192
ID3D8Device_GetClipPlane equ 196
ID3D8Device_SetRenderState equ 200
ID3D8Device_GetRenderState equ 204
ID3D8Device_BeginStateBlock equ 208
ID3D8Device_EndStateBlock equ 212
ID3D8Device_ApplyStateBlock equ 216
ID3D8Device_CaptureStateBlock equ 220
ID3D8Device_DeleteStateBlock equ 224
ID3D8Device_CreateStateBlock equ 228
ID3D8Device_SetClipStatus equ 232
ID3D8Device_GetClipStatus equ 236
ID3D8Device_GetTexture equ 240
ID3D8Device_SetTexture equ 244
ID3D8Device_GetTextureStageState equ 248
ID3D8Device_SetTextureStageState equ 252
ID3D8Device_ValidateDevice equ 256
ID3D8Device_GetInfo equ 260
ID3D8Device_SetPaletteEntries equ 264
ID3D8Device_GetPaletteEntries equ 268
ID3D8Device_SetCurrentTexturePalette equ 272
ID3D8Device_GetCurrentTexturePalette equ 276
ID3D8Device_DrawPrimitive equ 280
ID3D8Device_DrawIndexedPrimitive equ 284
ID3D8Device_DrawPrimitiveUP equ 288
ID3D8Device_DrawIndexedPrimitiveUP equ 292
ID3D8Device_ProcessVertices equ 296
ID3D8Device_CreateVertexShader equ 300
ID3D8Device_SetVertexShader equ 304
ID3D8Device_GetVertexShader equ 308
ID3D8Device_DeleteVertexShader equ 312
ID3D8Device_SetVertexShaderConstant equ 316
ID3D8Device_GetVertexShaderConstant equ 320
ID3D8Device_GetVertexShaderDeclaration equ 324
ID3D8Device_GetVertexShaderFunction equ 328
ID3D8Device_SetStreamSource equ 332
ID3D8Device_GetStreamSource equ 336
ID3D8Device_SetIndices equ 340
ID3D8Device_GetIndices equ 344
ID3D8Device_CreatePixelShader equ 348
ID3D8Device_SetPixelShader equ 352
ID3D8Device_GetPixelShader equ 356
ID3D8Device_DeletePixelShader equ 360
ID3D8Device_SetPixelShaderConstant equ 364
ID3D8Device_GetPixelShaderConstant equ 368
ID3D8Device_GetPixelShaderFunction equ 372
ID3D8Device_DrawRectPatch equ 376
ID3D8Device_DrawTriPatch equ 380
ID3D8Device_DeletePatch equ 384

;Flexible vertex format bits
D3DFVF_RESERVED0 equ 1h
D3DFVF_POSITION_MASK equ 0Eh
D3DFVF_XYZ equ 02h
D3DFVF_XYZRHW equ 4h
D3DFVF_XYZB1 equ 6h
D3DFVF_XYZB2 equ 8h
D3DFVF_XYZB3 equ 0ah
D3DFVF_XYZB4 equ 0ch
D3DFVF_XYZB5 equ 0eh
D3DFVF_NORMAL equ 10h
D3DFVF_PSIZE equ 20h
D3DFVF_DIFFUSE equ 40h
D3DFVF_SPECULAR equ 80h
D3DFVF_TEXCOUNT_MASK equ 0f00h
D3DFVF_TEXCOUNT_SHIFT equ 8
D3DFVF_TEX0 equ 0h
D3DFVF_TEX1 equ 100h
D3DFVF_TEX2 equ 200h
D3DFVF_TEX3 equ 300h
D3DFVF_TEX4 equ 400h
D3DFVF_TEX5 equ 500h
D3DFVF_TEX6 equ 600h
D3DFVF_TEX7 equ 700h
D3DFVF_TEX8 equ 800h
D3DFVF_LASTBETA_UBYTE4 equ 1000h
D3DFVF_RESERVED2 equ 0E000h

D3DPT_POINTLIST equ 1
D3DPT_LINELIST equ 2
D3DPT_LINESTRIP equ 3
D3DPT_TRIANGLELIST equ 4
D3DPT_TRIANGLESTRIP equ 5
D3DPT_TRIANGLEFAN equ 6

D3DTS_VIEW equ 2
D3DTS_PROJECTION equ 3
D3DTS_TEXTURE0 equ 16
D3DTS_TEXTURE1 equ 17
D3DTS_TEXTURE2 equ 18
D3DTS_TEXTURE3 equ 19
D3DTS_TEXTURE4 equ 20
D3DTS_TEXTURE5 equ 21
D3DTS_TEXTURE6 equ 22
D3DTS_TEXTURE7 equ 23
D3DTS_WORLD equ 256

D3DLIGHT_POINT equ 1
D3DLIGHT_SPOT equ 2
D3DLIGHT_DIRECTIONAL equ 3

D3DTSS_COLOROP equ 1
D3DTSS_COLORARG1 equ 2
D3DTSS_COLORARG2 equ 3
D3DTSS_ALPHAOP equ 4
D3DTSS_ALPHAARG1 equ 5
D3DTSS_ALPHAARG2 equ 6
D3DTSS_BUMPENVMAT00 equ 7
D3DTSS_BUMPENVMAT01 equ 8
D3DTSS_BUMPENVMAT10 equ 9
D3DTSS_BUMPENVMAT11 equ 10
D3DTSS_TEXCOORDINDEX equ 11
D3DTSS_ADDRESSU equ 13
D3DTSS_ADDRESSV equ 14
D3DTSS_BORDERCOLOR equ 15
D3DTSS_MAGFILTER equ 16
D3DTSS_MINFILTER equ 17
D3DTSS_MIPFILTER equ 18
D3DTSS_MIPMAPLODBIAS equ 19
D3DTSS_MAXMIPLEVEL equ 20
D3DTSS_MAXANISOTROPY equ 21
D3DTSS_BUMPENVLSCALE equ 22
D3DTSS_BUMPENVLOFFSET equ 23
D3DTSS_TEXTURETRANSFORMFLAGS equ 24
D3DTSS_ADDRESSW equ 25
D3DTSS_COLORARG0 equ 26
D3DTSS_ALPHAARG0 equ 27
D3DTSS_RESULTARG equ 28

D3DTOP_DISABLE equ 1
D3DTOP_SELECTARG1 equ 2
D3DTOP_SELECTARG2 equ 3
D3DTOP_MODULATE equ 4
D3DTOP_MODULATE2X equ 5
D3DTOP_MODULATE4X equ 6
D3DTOP_ADD equ 7
D3DTOP_ADDSIGNED equ 8
D3DTOP_ADDSIGNED2X equ 9
D3DTOP_SUBTRACT equ 10
D3DTOP_ADDSMOOTH equ 11
D3DTOP_BLENDDIFFUSEALPHA equ 12
D3DTOP_BLENDTEXTUREALPHA equ 13
D3DTOP_BLENDFACTORALPHA equ 14
D3DTOP_BLENDTEXTUREALPHAPM equ 15
D3DTOP_BLENDCURRENTALPHA equ 16
D3DTOP_PREMODULATE equ 17
D3DTOP_MODULATEALPHA_ADDCOLOR equ 18
D3DTOP_MODULATECOLOR_ADDALPHA equ 19
D3DTOP_MODULATEINVALPHA_ADDCOLOR equ 20
D3DTOP_MODULATEINVCOLOR_ADDALPHA equ 21
D3DTOP_BUMPENVMAP equ 22
D3DTOP_BUMPENVMAPLUMINANCE equ 23
D3DTOP_DOTPRODUCT3 equ 24
D3DTOP_MULTIPLYADD equ 25
D3DTOP_LERP equ 26

D3DTA_SELECTMASK equ 0fh
D3DTA_DIFFUSE equ 0
D3DTA_CURRENT equ 1
D3DTA_TEXTURE equ 2
D3DTA_TFACTOR equ 3
D3DTA_SPECULAR equ 4
D3DTA_TEMP equ 5
D3DTA_COMPLEMENT equ 10
D3DTA_ALPHAREPLICATE equ 20

D3DTADDRESS_WRAP equ 1
D3DTADDRESS_MIRROR equ 2
D3DTADDRESS_CLAMP equ 3
D3DTADDRESS_BORDER equ 4
D3DTADDRESS_MIRRORONCE equ 5

D3DTEXF_NONE equ 0
D3DTEXF_POINT equ 1
D3DTEXF_LINEAR equ 2
D3DTEXF_ANISOTROPIC equ 3
D3DTEXF_FLATCUBIC equ 4
D3DTEXF_GAUSSIANCUBIC equ 5

D3DTTFF_DISABLE equ 0
D3DTTFF_COUNT1 equ 1
D3DTTFF_COUNT2 equ 2
D3DTTFF_COUNT3 equ 3
D3DTTFF_COUNT4 equ 4
D3DTTFF_PROJECTED equ 256

D3DTSS_TCI_PASSTHRU equ 0h
D3DTSS_TCI_CAMERASPACENORMAL equ 10000h
D3DTSS_TCI_CAMERASPACEPOSITION equ 20000h
D3DTSS_TCI_CAMERASPACEREFLECTIONVECTOR equ 30000h

D3DUSAGE_RENDERTARGET equ 1
D3DUSAGE_DEPTHSTENCIL equ 2

D3DPOOL_DEFAULT equ 0
D3DPOOL_MANAGED equ 1
D3DPOOL_SYSTEMMEM equ 2

ID3D8Texture_GetDevice equ 12
ID3D8Texture_SetPrivateData equ 16
ID3D8Texture_GetPrivateData equ 20
ID3D8Texture_FreePrivateData equ 24
ID3D8Texture_SetPriority equ 28
ID3D8Texture_GetPriority equ 32
ID3D8Texture_PreLoad equ 36
ID3D8Texture_GetType equ 40
ID3D8Texture_SetLOD equ 44
ID3D8Texture_GetLOD equ 48
ID3D8Texture_GetLevelCount equ 52
ID3D8Texture_GetLevelDesc equ 56
ID3D8Texture_GetSurfaceLevel equ 60
ID3D8Texture_LockRect equ 64
ID3D8Texture_UnlockRect equ 68
ID3D8Texture_AddDirtyRect equ 72

D3DLOCK_READONLY equ 10h
D3DLOCK_DISCARD equ 2000h
D3DLOCK_NOOVERWRITE equ 1000h
D3DLOCK_NOSYSLOCK equ 800h
D3DLOCK_NO_DIRTY_UPDATE equ 8000h

D3DCMP_NEVER equ 1
D3DCMP_LESS equ 2
D3DCMP_EQUAL equ 3
D3DCMP_LESSEQUAL equ 4
D3DCMP_GREATER equ 5
D3DCMP_NOTEQUAL equ 6
D3DCMP_GREATEREQUAL equ 7
D3DCMP_ALWAYS equ 8

D3DBLEND_ZERO equ 1
D3DBLEND_ONE equ 2
D3DBLEND_SRCCOLOR equ 3
D3DBLEND_INVSRCCOLOR equ 4
D3DBLEND_SRCALPHA equ 5
D3DBLEND_INVSRCALPHA equ 6
D3DBLEND_DESTALPHA equ 7
D3DBLEND_INVDESTALPHA equ 8
D3DBLEND_DESTCOLOR equ 9
D3DBLEND_INVDESTCOLOR equ 10
D3DBLEND_SRCALPHASAT equ 11
D3DBLEND_BOTHSRCALPHA equ 12
D3DBLEND_BOTHINVSRCALPHA equ 13

D3DBLENDOP_ADD equ 1
D3DBLENDOP_SUBTRACT equ 2
D3DBLENDOP_REVSUBTRACT equ 3
D3DBLENDOP_MIN equ 4
D3DBLENDOP_MAX equ 5

D3DFILL_POINT equ 1
D3DFILL_WIREFRAME equ 2
D3DFILL_SOLID equ 3

D3DFOG_NONE equ 0
D3DFOG_EXP equ 1
D3DFOG_EXP2 equ 2
D3DFOG_LINEAR equ 3

D3DMCS_MATERIAL equ 0
D3DMCS_COLOR1 equ 1
D3DMCS_COLOR2 equ 2

D3DRS_ZENABLE equ 7
D3DRS_FILLMODE equ 8
D3DRS_SHADEMODE equ 9
D3DRS_LINEPATTERN equ 10
D3DRS_ZWRITEENABLE equ 14
D3DRS_ALPHATESTENABLE equ 15
D3DRS_LASTPIXEL equ 16
D3DRS_SRCBLEND equ 19
D3DRS_DESTBLEND equ 20
D3DRS_CULLMODE equ 22
D3DRS_ZFUNC equ 23
D3DRS_ALPHAREF equ 24
D3DRS_ALPHAFUNC equ 25
D3DRS_DITHERENABLE equ 26
D3DRS_ALPHABLENDENABLE equ 27
D3DRS_FOGENABLE equ 28
D3DRS_SPECULARENABLE equ 29
D3DRS_ZVISIBLE equ 30
D3DRS_FOGCOLOR equ 34
D3DRS_FOGTABLEMODE equ 35
D3DRS_FOGSTART equ 36
D3DRS_FOGEND equ 37
D3DRS_FOGDENSITY equ 38
D3DRS_EDGEANTIALIAS equ 40
D3DRS_ZBIAS equ 47
D3DRS_RANGEFOGENABLE equ 48
D3DRS_STENCILENABLE equ 52
D3DRS_STENCILFAIL equ 53
D3DRS_STENCILZFAIL equ 54
D3DRS_STENCILPASS equ 55
D3DRS_STENCILFUNC equ 56
D3DRS_STENCILREF equ 57
D3DRS_STENCILMASK equ 58
D3DRS_STENCILWRITEMASK equ 59
D3DRS_TEXTUREFACTOR equ 60
D3DRS_WRAP0 equ 128
D3DRS_WRAP1 equ 129
D3DRS_WRAP2 equ 130
D3DRS_WRAP3 equ 131
D3DRS_WRAP4 equ 132
D3DRS_WRAP5 equ 133
D3DRS_WRAP6 equ 134
D3DRS_WRAP7 equ 135
D3DRS_CLIPPING equ 136
D3DRS_LIGHTING equ 137
D3DRS_AMBIENT equ 139
D3DRS_FOGVERTEXMODE equ 140
D3DRS_COLORVERTEX equ 141
D3DRS_LOCALVIEWER equ 142
D3DRS_NORMALIZENORMALS equ 143
D3DRS_DIFFUSEMATERIALSOURCE equ 145
D3DRS_SPECULARMATERIALSOURCE equ 146
D3DRS_AMBIENTMATERIALSOURCE equ 147
D3DRS_EMISSIVEMATERIALSOURCE equ 148
D3DRS_VERTEXBLEND equ 151
D3DRS_CLIPPLANEENABLE equ 152
D3DRS_SOFTWAREVERTEXPROCESSING equ 153
D3DRS_POINTSIZE equ 154
D3DRS_POINTSIZE_MIN equ 155
D3DRS_POINTSPRITEENABLE equ 156
D3DRS_POINTSCALEENABLE equ 157
D3DRS_POINTSCALE_A equ 158
D3DRS_POINTSCALE_B equ 159
D3DRS_POINTSCALE_C equ 160
D3DRS_MULTISAMPLEANTIALIAS equ 161
D3DRS_MULTISAMPLEMASK equ 162
D3DRS_PATCHEDGESTYLE equ 163
D3DRS_PATCHSEGMENTS equ 164
D3DRS_DEBUGMONITORTOKEN equ 165
D3DRS_POINTSIZE_MAX equ 166
D3DRS_INDEXEDVERTEXBLENDENABLE equ 167
D3DRS_COLORWRITEENABLE equ 168
D3DRS_TWEENFACTOR equ 170
D3DRS_BLENDOP equ 171

D3DRTYPE_SURFACE equ 1
D3DRTYPE_VOLUME equ 2
D3DRTYPE_TEXTURE equ 3
D3DRTYPE_VOLUMETEXTURE equ 4
D3DRTYPE_CUBETEXTURE equ 5
D3DRTYPE_VERTEXBUFFER equ 6
D3DRTYPE_INDEXBUFFER equ 7

D3DSHADE_FLAT equ 1
D3DSHADE_GOURAUD equ 2
D3DSHADE_PHONG equ 3

D3DSBT_ALL equ 1
D3DSBT_PIXELSTATE equ 2
D3DSBT_VERTEXSTATE equ 3

D3DSTENCILOP_KEEP equ 1
D3DSTENCILOP_ZERO equ 2
D3DSTENCILOP_REPLACE equ 3
D3DSTENCILOP_INCRSAT equ 4
D3DSTENCILOP_DECRSAT equ 5
D3DSTENCILOP_INVERT equ 6
D3DSTENCILOP_INCR equ 7
D3DSTENCILOP_DECR equ 8

D3DVBF_DISABLE equ 0
D3DVBF_1WEIGHTS equ 1
D3DVBF_2WEIGHTS equ 2
D3DVBF_3WEIGHTS equ 3
D3DVBF_TWEENING equ 255
D3DVBF_0WEIGHTS equ 256

D3DZB_FALSE equ 0
D3DZB_TRUE equ 1
D3DZB_USEW equ 2

D3DCULL_NONE equ 1
D3DCULL_CW equ 2
D3DCULL_CCW equ 3

D3DWRAP_U equ 1
DWRAP_V equ 2
D3DWRAP_W equ 4
